#!/bin/bash
###############################################################################
# eVotUM - Electronic Voting System
#
# gen_rootCA_keypair.sh
#
# Bash script that generates root CA key pair.
#
#
# Copyright (c) 2016 Universidade do Minho
# Developed by José Pina Miranda - Devise Futures, Lda. (jose.miranda@devisefutures.com)
#
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
###############################################################################

# Begin Configuration - CHANGE AT YOUR OWN RISK -
KEY_BITS=4096
PKIPATH='/etc/evotum/pki'
SERIAL_FILE="${PKIPATH}/certserial/ECroot.serial"
# End Configuration

# Verifies if $SERIAL_FILE exists and get SERIAL number
if [ -f $SERIAL_FILE ]; then
  SERIAL=$(($(<$SERIAL_FILE) + 1))
else
  SERIAL=1
fi

echo $SERIAL > $SERIAL_FILE
KEY_FILE="${PKIPATH}/private/ca.key.${SERIAL}.pem"

# Generate CA key pair
printf "Generate root CA key pair to $KEY_FILE\n"
gen_RSAkeypair.sh $KEY_BITS $KEY_FILE
