#!/bin/bash
###############################################################################
# eVotUM - Electronic Voting System
#
# gen_RSAkeypair.sh
#
# Bash script that generates an RSA key pair with $1 bits and writes it to $2 in PEM format.
#
#
# Copyright (c) 2016 Universidade do Minho
# Developed by José Pina Miranda - Devise Futures, Lda. (jose.miranda@devisefutures.com)
#
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
###############################################################################

# Begin Configuration - CHANGE AT YOUR OWN RISK -

# End Configuration
###############################################################################
# start bash

if [  $# -lt 2 ]; then
    echo Usage: $0 "<key_pair_bits> <output_file>"
    echo Generates an RSA key pair with key_pair_bits and writes it to output_file in PEM format
    exit
fi

KEY_BITS=$1
KEY=$2

# Verifies if output_file exists
if [ -f $KEY ]; then
    echo Output file $KEY already existent. Key pair cannot be generated.
    exit
fi

# Generate key pair
openssl genrsa -aes128 -out $KEY $KEY_BITS
chmod 400 $KEY
